/**
 * Copyright 2006 by jFramework.org.
 */
package org.jframework.core.util;

import junitx.extensions.EqualsHashCodeTestCase;

import org.apache.commons.lang.builder.ToStringBuilder;

/**
 * Bean test.
 *
 * @author mgridnev
 * @version 1.0, Aug 3, 2006
 */
public class BeanTest extends EqualsHashCodeTestCase
{
    /**
     * Creates a test case
     */
    public BeanTest()
    {
        super("BeanTest");
    }

    /**
     * Creates an instance
     */
    protected Object createInstance()
    {
        return new TestBean("equal instance");
    }

    /**
     * Creates a non equal instance
     */
    protected Object createNotEqualInstance()
    {
        TestBean bean = new TestBean("not equal instance");
        bean.setID(1);

        return bean;
    }

    /**
     * Tests string representation
     */
    public void testToString()
    {
        TestBean bean = new TestBean("instance");

        assertEquals(ToStringBuilder.reflectionToString(bean), bean.toString());
    }

    /**
     * Test bean.
     */
    class TestBean extends Bean
    {
        private int ID;

        private String name;

        public TestBean(final String name)
        {
            this.name = name;
        }

        public int getID()
        {
            return ID;
        }

        public void setID(int ID)
        {
            this.ID = ID;
        }

        public String getName()
        {
            return name;
        }
    }
}
