/**
 * Copyright 2006 by jFramework.org.
 */
package org.jframework.core.util;

import junitx.extensions.EqualsHashCodeTestCase;

/**
 * Tests a pair.
 *
 * @author mgridnev
 * @version 1.0, Dec 1, 2006
 */
public class PairTest extends EqualsHashCodeTestCase
{
    /**
     * Creates a test
     */
    public PairTest(final String name)
    {
        super(name);
    }

    /**
     * Creates an equal instance
     */
    protected Object createInstance() throws Exception
    {
        return new Pair<String, String>("left", "right");
    }

    /**
     * Creates no equal instance
     */
    protected Object createNotEqualInstance() throws Exception
    {
        return new Pair<String, Integer>("left", 1);
    }

    /**
     * Tests the bea.
     */
    public void testBean()
    {
        final int id = 10;
        final String description = "ten";
        final Pair<Integer, String> pair = new Pair<Integer, String>(id, description);

        assertEquals(id, (int) pair.getLeft());
        assertEquals(description, pair.getRight());
    }

    /**
     * Tests single value.
     */
    public void testSingle()
    {
        final String value = "value";

        Pair<String, String> pair = Pair.create(value, null);
        assertEquals(Pair.create(value, null).hashCode(), pair.hashCode());
        assertEquals(Pair.create(value, null), pair);

        pair = Pair.create(null, value);
        assertEquals(Pair.create(null, value).hashCode(), pair.hashCode());
        assertEquals(Pair.create(null, value), pair);

        pair = Pair.create(null, null);
        assertEquals(Pair.create(null, null).hashCode(), pair.hashCode());
        assertEquals(Pair.create(null, null), pair);
    }
}
